Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx > Class Template Reference

Base class for linear Boolean constraints with coefficients. More...

`#include <linear.hh>`

## Public Member Functions

| LinBoolScale (Home home, SBAP &p, SBAN &n, VX x, int c)
| Constructor for creation.
| LinBoolScale (Space &home, Propagator &pr, SBAP &p, SBAN &n, VX x, int c)
| Constructor for cloning pr.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Attributes

SBAP | p
| Positive Boolean views with coefficients on left-hand side.
SBAN | n
| Negative Boolean views with coefficients on left-hand side.
VX | x
| Integer view on right-hand side.
int | c
| Integer constant on right-hand side.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Detailed Description

template<class SBAP, class SBAN, class VX, PropCond pcx>
class Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >

Base class for linear Boolean constraints with coefficients.

Definition at line 1220 of file linear.hh.

## Constructor & Destructor Documentation

## LinBoolScale() [1/2]

template<class SBAP, class SBAN, class VX, PropCond pcx>

Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::LinBoolScale | ( | Home | home,
|  | SBAP & | p,
|  | SBAN & | n,
|  | VX | x,
|  | int | c )

inline

Constructor for creation.

Definition at line 156 of file bool-scale.hpp.

## LinBoolScale() [2/2]

template<class SBAP, class SBAN, class VX, PropCond pcx>

Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::LinBoolScale | ( | Space & | home,
|  | Propagator & | pr,
|  | SBAP & | p,
|  | SBAN & | n,
|  | VX | x,
|  | int | c )

inline

Constructor for cloning pr.

Definition at line 192 of file bool-scale.hpp.

## Member Function Documentation

## cost()

template<class SBAP, class SBAN, class VX, PropCond pcx>

PropCost Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low linear).

Implements Gecode::Propagator.

Definition at line 167 of file bool-scale.hpp.

## reschedule()

template<class SBAP, class SBAN, class VX, PropCond pcx>

void Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 174 of file bool-scale.hpp.

## dispose()

template<class SBAP, class SBAN, class VX, PropCond pcx>

size_t Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 182 of file bool-scale.hpp.

## Member Data Documentation

## p

template<class SBAP, class SBAN, class VX, PropCond pcx>

SBAP Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::p

protected

Positive Boolean views with coefficients on left-hand side.

Definition at line 1223 of file linear.hh.

## n

template<class SBAP, class SBAN, class VX, PropCond pcx>

SBAN Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::n

protected

Negative Boolean views with coefficients on left-hand side.

Definition at line 1225 of file linear.hh.

## x

template<class SBAP, class SBAN, class VX, PropCond pcx>

VX Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::x

protected

Integer view on right-hand side.

Definition at line 1227 of file linear.hh.

## c

template<class SBAP, class SBAN, class VX, PropCond pcx>

int Gecode::Int::Linear::LinBoolScale< SBAP, SBAN, VX, pcx >::c

protected

Integer constant on right-hand side.

Definition at line 1229 of file linear.hh.

The documentation for this class was generated from the following files:

- gecode/int/linear.hh
- gecode/int/linear/bool-scale.hpp